package net;

import game.Game;
import human.HumanDisplay;
import human.HumanStrategy;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.net.URL;


import lemonade.ScaledLemonadeUtility;

public class LemonadeApplet extends Applet{
  /**
   * 
   */
  private static final long serialVersionUID = 1L;
  Thread gameThread;
  
  HumanRemoteClient client;
  public void init(){
    Game g = new Game(new int[] { 12, 12, 12 }, new ScaledLemonadeUtility(12));
    HumanDisplay display = new HumanDisplay(g);
    HumanStrategy constantStrategy = new HumanStrategy(g, display);
    display.addMouseListener(constantStrategy);
    setLayout(new BorderLayout());
    add(display,BorderLayout.CENTER);
    client = new HumanRemoteClient(constantStrategy,g);
    ChatPanel panel = new ChatPanel(client);
    add(panel,BorderLayout.SOUTH);
    URL url = this.getCodeBase();
    System.out.println(url.toString());
    client.serverName = url.getHost();
    System.err.println(client.serverName);
    if (client.serverName==""){
      client.serverName="localhost";
    }

  }
  @Override
  public String getAppletInfo() {
    return "The Lemonade Stand Game by Martin Zinkevich";
  }
  
  
  @Override
  public void start() {
    
    try{
    while(client.state==HumanRemoteClient.SHUTTING_DOWN){
      Thread.sleep(20);
    }
    Thread.sleep(1000);
    
    if (gameThread==null || !gameThread.isAlive()){
      gameThread = new Thread(client);
      gameThread.start();
    }
    } catch (InterruptedException ie){
      ie.printStackTrace();
    }
  }
  @Override
  public void stop() {
    client.stop();
    gameThread.interrupt();
    
  }
  
  
  
  


  
  
  
  
  
}
